

# HW05: Add some ConsList Methods

For this assignment, you will design four methods for the provided
ConsList implementation:


**Take**

```xs.take(nn)``` creates a new list containing the first nn elements of this list.

Example: ```ConsList.of("a", "b", "c", "d").take(2)``` => ```ConsList.of("a", "b")```


**Drop**

```xs.drop(nn)``` produces a new list containing the elements of this
list except for the first nn elements.

Example: ```ConsList.of("a", "b", "c", "d").drop(1)``` => ```ConsList.of("b", "c", "d")```


**Append**

The append method creates a new list by sticking another list on the end of this one.

Example: 
```ConsList.of("a", "b").append(ConsList.of("c", "d"))``` => 
```ConsList.of("a", "b", "c", "d")```


**Rotate**

```xs.rotate(nn)``` produces a new list containing the elements of the
input list rotated left by nn positions.

Example: ```ConsList.of("a", "b", "c", "d").rotate(1)``` =>
```ConsList.of("b", "c", "d", "a")```


## Hints

Because ConsList is an interface rather than a class or record, adding
a new method requires changes in 3 places:

 - The stub and javadoc goes in the interface.
 - In each of the two records implementing the interface, you start with
   @Override, don't need JavaDoc, and handle the logic for that particular
   list variant.



